﻿using Autofac;
using SegMyBill.Web.Application.Service.Contracts;
using SegMyBill.Web.Application.Service.Implementations;
using SegMyBill.Web.Infrastructure.Repository.AutofacModules;

namespace SegMyBill.Web.Application.Service.AutofacModules
{
    public class AutofacApplicationModule: Autofac.Module
    {
        protected override void Load(ContainerBuilder builder)
        {
            builder.RegisterModule(new AutofacRepositoryModule());
            builder.RegisterType<UserService>().As<IUserService>();
            builder.RegisterType<TemplateService>().As<ITemplateService>();

            base.Load(builder);
        }
    }
}
