﻿using AutoMapper;
using SegMyBill.Web.Application.Service.Contracts;
using SegMyBill.Web.Domain.Entities;
using SegMyBill.Web.Domain.RepositoryContracts.Contracts;
using SegMyBill.Web.Infrastructure.Models.DataModels;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace SegMyBill.Web.Application.Service.Implementations
{
    public class TemplateService : ITemplateService
    {
        
        private readonly IMapper _mapper;
        private readonly ITemplateRepository _templateRepository;

        public TemplateService(IMapper mapper, ITemplateRepository templateRepository)
        {
            _mapper = mapper;
            _templateRepository = templateRepository;
        }
        
        public Task<bool> createTemplate(TemplateEntity template)
        {
            var mappedTemplate = _mapper.Map<Template>(template);
            var succes = _templateRepository.createTemplate(mappedTemplate);
            return succes;
        }

        public Task<bool> deleteTemplate(string name)
        {
            var succes = _templateRepository.deleteTemplate(name);
            return succes;
        }

        public async Task<IEnumerable<TemplateEntity>> GetAll()
        {
            return _mapper.Map<IEnumerable<TemplateEntity>>(_templateRepository.GetAll().Result);
        }

        public async Task<TemplateEntity> GetTemplateByName(string templateName)
        {
            return _mapper.Map<TemplateEntity>(_templateRepository.GetTemplateByName(templateName).Result);
        }
    }
}
