﻿using AutoMapper;
using SegMyBill.Web.Application.Service.Contracts;
using SegMyBill.Web.Domain.Entities;
using SegMyBill.Web.Domain.RepositoryContracts.Contracts;
using SegMyBill.Web.Infrastructure.Models.DataModels;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace SegMyBill.Web.Application.Service.Implementations
{
    public class UserService : IUserService
    {        
        private readonly IMapper _mapper;
        private readonly IUserRepository _userRepository;

        public UserService(IMapper mapper, IUserRepository userRepository)
        {
            _mapper = mapper;
            _userRepository = userRepository;
        }

        public Task<bool> createUser(UserEntity user)
        {
            var mappedUser = _mapper.Map<User>(user);
            var succes = _userRepository.createUser(mappedUser);
            return succes;
        }

        public Task<bool> deleteUser(string email)
        {
            var succes = _userRepository.deleteUser(email);
            return succes;
        }

        public async Task<UserEntity> findByEmail(string email)
        {
            return _mapper.Map<UserEntity>(_userRepository.findByEmail(email).Result);
        }

        public async Task<IEnumerable<UserEntity>> GetAll()
        {
            return _mapper.Map<IEnumerable<UserEntity>>(_userRepository.GetAll().Result);
        }

    }
}
