﻿using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using SegMyBill.Web.Domain.RepositoryContracts.Contracts;
using SegMyBill.Web.Infrastructure.Repository.Implementations;

namespace SegMyBill.Web.Infrastructure.Repository.Extentions
{
    public static class RepositoriesExtention
    {
        public static IServiceCollection AddRepositoriesServices(this IServiceCollection services, IConfiguration config)
        {
            services.AddTransient<IUserRepository, UserRepository>();
            services.AddTransient<ITemplateRepository, TemplateRepository>();

            /* TODO: CONNECCIÓ AMB DATABASE 
            services.AddHealthChecks().AddSqlServer(config.GetConnectionString("JsonTreeDb"));

            services.AddDbContext<PerkDbContext>(options =>
            {
                options.UseSqlServer(config.GetConnectionString("JsonTreeDb"));
                options.LogTo(Console.WriteLine, new[] { RelationalEventId.CommandExecuted });
            });
            */
            return services;
        }
    }
}
