﻿using Google.Cloud.Firestore;
using SegMyBill.Web.Domain.RepositoryContracts.Contracts;
using SegMyBill.Web.Infrastructure.Models.Contexts;
using SegMyBill.Web.Infrastructure.Models.DataModels;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace SegMyBill.Web.Infrastructure.Repository.Implementations
{
    public class TemplateRepository : ITemplateRepository
    {
        public async Task<bool> createTemplate(Template template)
        {
            var succes = true;

            try
            {
                FirestoneDBContext _context = new FirestoneDBContext();
                var docRef = _context.DataBase.Collection("yamls").Document(template.TemplateName);
                var result = await docRef.SetAsync(template); //TODO: CONTROL AMB WRITERESULT
            }
            catch (Exception ex)
            {
                succes = false;
            }
            return succes;
        }

        public async Task<bool> deleteTemplate(string name)
        {
            var succes = true;

            try
            {
                FirestoneDBContext _context = new FirestoneDBContext();

                var docRef = _context.DataBase.Collection("yamls").Document(name);

                if (docRef.GetSnapshotAsync().Result.Exists)
                {
                    var result = await docRef.DeleteAsync();
                }
                else
                {
                    succes = false;
                }
                
            }
            catch (Exception ex) //TODO: WRITERESULT CONTROL
            {
                succes = false;
            }
            return succes;
        }

        public async Task<IEnumerable<Template>> GetAll()
        {
            List<Template> templateList = new List<Template>();

            FirestoneDBContext _context = new FirestoneDBContext();
            var docQuery = _context.DataBase.Collection("yamls").WhereNotEqualTo("TemplateName", null);
            var result = await docQuery.GetSnapshotAsync();

            foreach (var document in result.Documents)
            {
                var newTemplate = document.ConvertTo<Template>();
                templateList.Add(newTemplate);
            }

            return templateList;
        }

        public async Task<Template> GetTemplateByName(string templateName)
        {
            FirestoneDBContext _context = new FirestoneDBContext();
            var docRef = _context.DataBase.Collection("yamls").Document(templateName);
            var result = await docRef.GetSnapshotAsync();

            return result.ConvertTo<Template>();
        }
    }
}
