import { BrowserModule } from '@angular/platform-browser';
import { CUSTOM_ELEMENTS_SCHEMA, NgModule } from '@angular/core';
import { HttpClientModule } from '@angular/common/http';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { CoreModule } from './core/core.module';
import { CorePagesModule } from './core/pages/core-pages.module';

import { AppComponent } from './app.component';
import { MainPage } from './pages-module/pages/main/main.page';

// Router
import { CORE_ROUTES } from './core/pages/core-pages.routes';
import { SharedModule } from './shared/shared.module';


@NgModule({
  declarations: [ AppComponent, MainPage ],
  imports: [
    BrowserModule, //.withServerTransition({ appId: 'ng-cli-universal' }),
    BrowserAnimationsModule,
    HttpClientModule,
    CoreModule,
    CorePagesModule,
    SharedModule,

    CORE_ROUTES
  ],
  bootstrap: [AppComponent],
  schemas: [CUSTOM_ELEMENTS_SCHEMA]
})
export class AppModule { }