import { Routes, RouterModule } from '@angular/router';
import { AuthGuardService } from '../services/auth-guard.service';

// Components
import { MainPage } from '../../pages-module/pages/main/main.page';
import { HomePage } from './home/home.page';
import { LoginPage } from './login/login.page';
import { SignupPage } from './signup/signup.page';
import { TutorialsPage } from './tutorials/tutorials.page';
import { NotFoundPage } from './not-found/not-found.page';


const coreRoutes: Routes = [
    { 
        path: '',
        canActivate: [],
        component: MainPage,
        children: [
            { path: 'login', component: LoginPage },
            { path: 'signup', component: SignupPage },
            { path: 'tutorials', component: TutorialsPage },
            { path: 'home', component: HomePage },
            { path: '', redirectTo: 'home', pathMatch: 'full' },
        ]
    },
    {
        path: 'app',
        canActivate: [AuthGuardService],
        component: MainPage,
        loadChildren: () => import('../../pages-module/pages.module').then(m => m.PagesModule)
    },
    { path: '**', component: NotFoundPage },
];
export const CORE_ROUTES = RouterModule.forRoot( coreRoutes, { useHash: true, relativeLinkResolution: 'legacy' } );