import { Component, OnInit } from '@angular/core';
import { FormBuilder, FormGroup, Validators } from '@angular/forms';
import { Router } from '@angular/router';
import { SignService } from '../../services/sign.service';

@Component({
    selector: 'app-signup',
    templateUrl: './signup.page.html'
})
export class SignupPage implements OnInit {
    public form: FormGroup;

    constructor(
        private router: Router,
        private signService: SignService,
        private formBuilder: FormBuilder
    ) {
        this.form = this.formBuilder.group({
            Email: [null, [Validators.required, Validators.email]],
            Username:[null, Validators.required],
            Password: [null, Validators.required],
            Password2: [null, Validators.required],
            Role: 1
        });
    }

    public ngOnInit(): void { }

    public async onSingUp(): Promise<void> {
        try {
            let signup = await this.signService.signUp(this.form.value).toPromise();
            this.signService.setUserInStorage(signup.Response);
            this.router.navigate(['/app/templates']);
        } catch (err) {
            throw err;
        }
    }

}