import { Injectable } from '@angular/core';
import { Router, CanActivate } from '@angular/router';
import { SignService } from './sign.service';

@Injectable({ providedIn: 'root' })
export class AuthAdminGuardService implements CanActivate {
    constructor(
        public router: Router,
        private signService: SignService
    ) { }

    async canActivate(): Promise<boolean> {
        if (localStorage.getItem('segmybill_token')) {
            const token = localStorage.getItem('segmybill_token');
            let role = await this.signService.getIsAdmin().toPromise();
            let isAdmin = role?.Response == 'Admin'; 

            if (
                token !== null &&
                token !== '' &&
                isAdmin
            ) {
                return true;
            } else {
                this.router.navigate(['home']);
                return false;
            }
        } else {
            this.signService.logout();
            this.router.navigate(['login']);
            return false;
        }
    }
}
