import { Injectable } from '@angular/core';
import { Router, CanActivate } from '@angular/router';
import { SignService } from './sign.service';

@Injectable({ providedIn: 'root' })
export class AuthGuardService implements CanActivate {
    constructor(
        public router: Router,
        private signService: SignService
    ) { }

    canActivate(): boolean {
        if (localStorage.getItem('segmybill_token')) {
            const token = localStorage.getItem('segmybill_token');

            if (token !== null && token !== '') {
                return true;
            } else {
                this.signService.logout();
                this.router.navigate(['login']);
                return false;
            }
        } else {
            this.signService.logout();
            this.router.navigate(['login']);
            return false;
        }
    }
}
