import { Routes, RouterModule } from '@angular/router';
import { AuthGuardService } from '../core/services/auth-guard.service';
import { AuthAdminGuardService } from '../core/services/auth-admin-guard.service';

// Components
import { HomePage } from '../core/pages/home/home.page';
import { TemplatesPage } from './pages/templates/templates.page';
import { ComunityPage } from './pages/comunity/comunity.page';


const pagesRoutes: Routes = [
    { path: 'home', component: HomePage, canActivate: [AuthGuardService] },
    { path: 'templates', component: TemplatesPage, canActivate: [AuthGuardService] },
    { path: 'community', component: ComunityPage, canActivate: [AuthAdminGuardService] },
    { path: '', redirectTo: 'home', pathMatch: 'full' }
];

export const PAGES_ROUTES = RouterModule.forChild(pagesRoutes);