import { Directive, EventEmitter, HostBinding, HostListener, Output } from "@angular/core";

@Directive({
    selector: '[appDragDrop]'
})
export class DragDropDirective {
    @HostBinding('class.fileover') fileOver: boolean;
    @Output() fileDropped: EventEmitter<any> = new EventEmitter();
    
    constructor() { }

    @HostListener('dragover', ['$event']) onDragOver(evt: Event) {
        evt.preventDefault();
        evt.stopPropagation();
        this.fileOver = true;
    }

    @HostListener('dragleave', ['$event']) onDragLeave(evt: Event) {
        evt.preventDefault();
        evt.stopPropagation();
        this.fileOver = false;
    }

    @HostListener('drop', ['$event']) onDrop(evt) {
        evt.preventDefault();
        evt.stopPropagation();

        this.fileOver = false;
        const files = evt.dataTransfer.files;

        if (files.length === 1) {
            this.fileDropped.emit(files);
        }

    }

}