import { HttpHeaders } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { Observable } from "rxjs";
import { CoreService } from "../../core/services/core.service";


@Injectable({ providedIn: 'root' })
export class TemplatesService extends CoreService {
    private route = '/templates';
    private routeSegmented = '/getSegmentatedBill';

    public getTemplates(): Observable<any> {
        return this.get(this.route);
    }

    public addTemplate(formData: any): Observable<any> {
        const headers = new HttpHeaders();
        headers.set('content-type', 'multipart/form-data');
        headers.set('Accept', '*/*');
        return this.post(`${this.route}/new`, formData, headers);
    }

    public selectTemplate(formData: any): Observable<any> {
        const headers = new HttpHeaders();
        headers.set('content-type', 'multipart/form-data');
        headers.set('Accept', '*/*');
        return this.post(this.routeSegmented, formData, headers);
    }
    
    public removeTemplate(name: string): Observable<any> {
        return this.delete(`${this.route}/delete?name=${name}`);
    }
}