import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { SignService } from '../../../core/services/sign.service';

@Component({
    selector: 'app-nav-menu',
    templateUrl: './nav-menu.component.html',
    styleUrls: ['./nav-menu.component.css']
})
export class NavMenuComponent implements OnInit {
    public isExpanded = false;
    public isAdmin: boolean = false;

    constructor(private router: Router, public signService: SignService) {}

    public async ngOnInit(): Promise<void> {
        let role = await this.signService.getIsAdmin().toPromise();
        this.isAdmin = role?.Response == 'Admin';
    }


    public collapse(): void {
        this.isExpanded = false;
    }

    public toggle(): void {
        this.isExpanded = !this.isExpanded;
    }

    public goTo(url: string): void {
        this.isExpanded = false;
        this.router.navigate([url]);
    }

    public logOut(): void {
        this.signService.logout();
        this.router.navigate(['/login']);
    }
}
