﻿using AutoMapper;
using Microsoft.Extensions.DependencyInjection;
using SegMyBill.Web.Distributed.DTO.MappingConfigurations;
using SegMyBill.Web.Application.Service.MappingConfigurations;

namespace SegMyBill.Web.Extensions
{
    public static class AutoMapperExtention
    {
        public static IServiceCollection AddAutomapperServices(this IServiceCollection services)
        {
            var mappingConfig = new MapperConfiguration(mc =>
            {
                mc.AddProfile(new TemplateDistributedProfile());
                mc.AddProfile(new UserDistributedProfile());
                mc.AddProfile(new TemplateApplicationProfile());
                mc.AddProfile(new UserApplicationProfile());
            });

            IMapper mapper = mappingConfig.CreateMapper();
            services.AddSingleton(mapper);
            return services;

        }
    }
}
