import codecs
import json
import datetime


def datetime_parser(date):
    # Serialitza el datetime
    if isinstance(date, datetime.datetime):
        return date.__str__()


def write_json(extraction, file_path):
    # Crea un .json al path que se li passa per parametre amb el contingut final de les dades extretes.

    # S'assegura que el path contingui l'extensió del fitxer, que serà un .json
    if not file_path.endswith(".json"):
        file_path += ".json"

    # obra un document amb el encoding seleccionat amb permís s'escriptura i anem passant una a una cada linia
    with codecs.open(file_path, "w", encoding="utf-8") as j_file:
        for line in extraction:
            for field, field_value in line.items():
                # Sempre que contingui la paraula date a la field passa a string el datetime
                if field.endswith("date") or field.startswith("date"):
                    line[field] = field_value.strftime("%d-%m-%Y")
        json.dump(
            extraction,
            j_file,
            indent=4,
            sort_keys=True,
            default=datetime_parser,
            ensure_ascii=False,
        )