import re

# Aquestes variables son les que es possible que generin salts de linia o separacions
SEPARATORS = {"line_separator": r"\n", "field_separator": r"\s+"}


def pull_out(self, bill_string, extraction):
    # Per cada taula que hi ha extreu el seu contingut
    for table in self["tables"]:

        # Li agraguem a la table la nova configuració amb el field_separator i el line_separator
        table_config = SEPARATORS.copy()
        table_config.update(table)
        table = table_config

        # Comprova que dins de la configuració hi hagin les keys necessaries
        assert "begin" in table, "Falta parametre begin de la taula"
        assert "finish" in table, "Falta parametre finish de la taula"
        assert "content" in table, "Falta parametre content de la taula"

        # Si existeix dins de la factura i hi ha una coinidencia retorna un objecte Match
        finish = re.search(table["finish"], bill_string)
        begin = re.search(table["begin"], bill_string)

        # No s'ha pogut determinar el contingut de la taula
        if not begin or not finish:
            continue

        # Es retalla la part del string a on tenim l'inici i el final de les coincidencies
        table_content = bill_string[begin.end(): finish.start()]

        # Per cada fragment que ens retorna el split per cada separador
        for line in re.split(table["line_separator"], table_content):
            # En cas que no hi ha contingut o es un salt de linia passa a la seguent linia
            if not line or not line.strip("").strip("\n"):
                continue

            # Busca el patró dins de la linia en cas que no sigui None, significa que ha trobat la coincidencia
            coincidence = re.search(table["content"], line)
            if coincidence:
                for coincidence_field, coincidence_value in coincidence.groupdict().items():
                    # mirem si el camp ja existeix dins del output
                    if coincidence_field in extraction:
                        continue

                    # Fem els converts necessaris per assignar-li el tipus correcte segons el nom del camp
                    # Un cop fets l'afegim a l'extracció final amb el camp extret i el seu valor
                    if coincidence_field.startswith("amount") or coincidence_field.endswith("amount"):
                        extraction[coincidence_field] = self.clean_number(coincidence_value)
                    elif coincidence_field.endswith("date") or coincidence_field.startswith("date"):
                        extraction[coincidence_field] = self.parse_date_by_format(coincidence_value)
                        if not extraction[coincidence_field]:
                            # TODO THROW EXCEPTION: HA FALLAT EL PARSE A DATETIME
                            return None
                    else:
                        extraction[coincidence_field] = coincidence_value
            # Si no compleix la coincidencia, anem a la seguent
