from collections import OrderedDict
import re


def parse(bill_template, field_name, field_content, bill_string, listing=False):
    # Aquest metode s'encarrega d'extreure el contingut de resex plans

    pattern_result = []

    if "regex" not in field_content:
        # TODO THROW EXCEPTION: NO TE UN RESEX ESPESIFICAT
        return None

    # el contingut del camp el vull tractar sempre de la meteixa forma, per aixo
    # en cas que no ho sigui s'incorpora a una
    if isinstance(field_content["regex"], list):
        pattern = field_content["regex"]
    else:
        pattern = [field_content["regex"]]

    # Per cada patró trobat en el camp:
    for pattern_found in pattern:
        # A partir de la llibreria de resex li passem el patró i el string a trobar el patró
        coincidences = re.findall(pattern_found, bill_string)
        if coincidences:  # Ha trobat el patró a la factura que que no es null
            for coincidence in coincidences:  # per cada cop que s'ha trobat el patró
                if isinstance(coincidence, tuple):  # comprova que no sigui una tupla el contingut del match
                    if(field_name == "date"):
                        pattern_result.append(coincidence[0])
                    else:
                        # TODO THROW EXCEPTION: LA COINCIDENCIA NO POT CONTENIR MULTIPLES GRUPS
                        return None
                else:
                    pattern_result += coincidences  # Afegeix el contingut del que s'ha trobat a la llista

    if "type" in field_content:  # Comprova que tingui un type assignat
        for key, value in enumerate(pattern_result):
            # Canvia de string al type que li pertoca
            pattern_result[key] = bill_template.to_type(value, field_content["type"])

    # Agrega dins d'un container segons el tipus passat per parametre i aixo permetrà eliminar duplicats
    if listing:
        pattern_result = list(set(pattern_result))
    else:
        pattern_result = list(OrderedDict.fromkeys(pattern_result))

    # En cas de tenir una llista només agafar el seu primer valor
    if isinstance(pattern_result, list) and len(pattern_result) == 1:
        pattern_result = pattern_result[0]

    return pattern_result
