from .fileUtils import to_json
from .textConverter import pdftotext
from .segmentation.loader import read_templates

import argparse


def extract_data_from_pdf(invoicefile):
    template = read_templates()

    extracted_str = pdftotext.pdf_to_text(invoicefile).decode("utf-8")

    # pimer s'assegura de que el template sigui correcte a través de les must to words trobades al string
    if template.matches_all_mtw(extracted_str):
        # crida per fer l'extraccions de camps de dins de la factura buscant patrons
        return template.extract(extracted_str)

    return False


def create_parser():
    # Fa el control de arguments per si es vol executar sense la api

    parser = argparse.ArgumentParser(
        description="Extract structured data from PDF files and save to JSON."
    )

    parser.add_argument(
        "input_files",
        type=argparse.FileType("r"),
        nargs="+",
        help="File or directory to analyze.",
    )

    return parser


def main(args=None):
    if args is None:
        parser = create_parser()
        args = parser.parse_args()

    extraction = []
    for pdfFile in args.input_files:  # TODO: multifactura
        # args.input_files = Direccions de cada pdf que s'ha passat
        result = extract_data_from_pdf(pdfFile.name)
        # Ja tenim les dades extretes, parametres: localització del fitxer, totes les plantilles, pdftotext

        if result:  # si no es null:
            extraction.append(result)
        pdfFile.close()

    to_json.write_json(extraction, "segmentatedBill")
