from distutils import spawn
import subprocess


def pdf_to_text(path):
    # Serveix com a funció de pdf a text a través de la llibreria Poppler pdftotext.
    if spawn.find_executable("pdftotext"):
        # obre un subproces de la llibrearia per extreure el text del pdf
        text, error = subprocess.Popen(
            ["pdftotext", "-layout", "-enc", "UTF-8", path, "-"], stdout=subprocess.PIPE
        ).communicate()
        return text
    else:
        raise EnvironmentError(
            "La dependencia pdftotext no esta instalada en l'entorn."
        )
